<control-category-select>

	<div class="category-select">
		<a href="#" id="category-button" class="category-button { !state.path ? 'unset' : '' } { opts.disabled ? 'disabled' : '' }" onclick="{ toggle_selector }">
			{ state.path || 'Επιλογή κατηγορίας' }
		</a>

		<div class="categories { state.select_mode ? 'expanded' : '' }">
			<div class="options { state.active_level == 0 ? 'active' : '' }">
				<ul>
					<li each="{ category in state.categories }" if="{ category.parent_id == 0 && category.allowed }">
						<a href="#" class="{ state.levels[0].id == category.id ? 'selected' : '' }" onclick="{ category_change }">
							{ category.title }
							<i class="fa fa-caret-right" if="{ category.has_children }"></i>
							<i class="fa fa-check" if="{ !category.has_children && category.id == state.selected }"></i>
						</a>
					</li>
				</ul>
			</div>

			<div class="options { state.active_level == 1 ? 'active' : '' }" if="{ state.levels[0].id > 0 && state.levels[0].has_children }">
				<a href="#" class="title" data-level="1" onclick="{ go_back }"><i class="fa fa-caret-left"></i> { state.levels[0].title }</a>
				<ul>
					<li each="{ category in state.categories }" if="{ category.parent_id == state.levels[0].id || category.alias_parent_id == state.levels[0].id }">
						<a href="#" class="{ state.levels[1].id == category.id ? 'selected' : '' }" onclick="{ category_change }">
							{ category.title }
							<i class="fa fa-caret-right" if="{ category.has_children }"></i>
							<i class="fa fa-check" if="{ !category.has_children && category.id == state.selected }"></i>
						</a>
					</li>
				</ul>
			</div>

			<div class="options { state.active_level == 2 ? 'active' : '' }" if="{ state.levels[1].id > 0 && state.levels[1].has_children }">
				<a href="#" class="title" data-level="2" onclick="{ go_back }"><i class="fa fa-caret-left"></i> { state.levels[1].title }</a>
				<ul>
					<li each="{ category in state.categories }" if="{ category.parent_id == state.levels[1].id || category.alias_parent_id == state.levels[1].id }">
						<a href="#" class="{ state.levels[2].id == category.id ? 'selected' : '' }" onclick="{ category_change }">
							{ category.title }
							<i class="fa fa-caret-right" if="{ category.has_children }"></i>
							<i class="fa fa-check" if="{ !category.has_children && category.id == state.selected }"></i>
						</a>
					</li>
				</ul>
			</div>

			<div class="options { state.active_level == 3 ? 'active' : '' }" if="{ state.levels[2].id > 0 && state.levels[2].has_children }">
				<a href="#" class="title" data-level="3" onclick="{ go_back }"><i class="fa fa-caret-left"></i> { state.levels[2].title }</a>
				<ul>
					<li each="{ category in state.categories }" if="{ category.parent_id == state.levels[2].id || category.alias_parent_id == state.levels[2].id }">
						<a href="#" class="{ state.levels[3].id == category.id ? 'selected' : '' }" onclick="{ category_change }">
							{ category.title }
							<i class="fa fa-caret-right" if="{ category.has_children }"></i>
							<i class="fa fa-check" if="{ !category.has_children && category.id == state.selected }"></i>
						</a>
					</li>
				</ul>
			</div>
		</div>

		<loader-icon class="control-loader" if="{ state.loading }"></loader-icon>
	</div>

	<script>
	/*
		Methods:
		initialize( categories array ) :: initialize the control with the categories in an array
		set_allowed_categories( categories ids ) :: sets the categories (array of ids) to display if member is professional
		set_value( location id ) :: sets the location to select
		get_value() :: returns the selected location id

		Events:
		onchangehandler( category ) :: triggers when a last child category is selected
	*/
		this.state = {
			path: "",
			selected: 0,
			select_mode: false,
			identifier: null,

			//select_mode: false,
			display_aliases: (this.opts.displayaliases === 'true' ? true : false), // false: will not display alias categories
			select_root: (this.opts.selectroot === 'true' ? true : false), // true: allow user to select root category
			select_last: (this.opts.selectlast === 'false' ? false : true), // true: user must select the last child of root category

			categories: [],
			allowed_categories: [], //categories (ids) allow to display and select
			
			levels: [ {	title: '', id: 0, has_children: false }, { title: '', id: 0, has_children: false }, { title: '', id: 0, has_children: false }, { title: '', id: 0, has_children: false } ],
			active_level: 0,

			loading: false,
		}


		// sets the categories (array of ids) to display (if member is professional, show only the categories assigned to member)
		this.set_allowed_categories = categories => {
			this.state.allowed_categories = categories;
		}


		this.set_value = id => {
			this.state.selected = id;
			if (!this.state.categories.length && !this.state.loading) {
				this.load_categories();
			} else {
				this.set_selected_categories();
			}
		}


		this.get_value = () => {
			return this.state.selected;
		}


		// Sets the select inputs with the selected categories
		this.set_selected_categories = () => {

			if (this.state.categories.length) {

				this.init_levels(0);
				
				// find location in list
				var category = this.category_find(this.state.selected);
				
				while (category) {
					var level = this.get_level(category.id);
					this.state.levels[level].id = category.id;
					this.state.levels[level].title = category.title;
					this.state.levels[level].has_children = category.has_children;

					category = this.category_find(category.parent_id);
				}
				this.state.path = this.get_path(this.state.selected);

				this.update();
			}
		}


		this.set_identifier = identifier => {
			this.state.identifier = identifier;
		}
		this.get_identifier = () => {
			return this.state.identifier;
		}


		// Initialize the "levels" array in state
		this.init_levels = level => {
			for (var i = level; i < 3; i++) {
				this.state.levels[i].id = 0;
				this.state.levels[i].title = '';
				this.state.levels[i].has_children = false;
			}
		}


		// returns the location with "id"
		this.category_find = id => {
			return this.state.categories.find( item => item.id == id ) || null;
		}


		this.toggle_selector = event => {
			if (typeof event !== 'undefined') {
				event.preventDefault();
			}

			if (!this.opts.disabled) {
				this.state.select_mode = !this.state.select_mode;
			}
		}


		this.category_change = event => {
			event.preventDefault();

			// get category level
			var level = this.get_level(event.item.category.id);

			if (this.state.levels[level] != event.item.category.id) {

				//unselect all categories from sub levels
				this.init_levels(level);

				// select current category
				this.state.levels[level].id = event.item.category.id;
				this.state.levels[level].title = event.item.category.title;
				this.state.levels[level].has_children = event.item.category.has_children;

				if (event.item.category.has_children) {
					this.state.active_level = level + 1;
				} else {

					this.state.selected = event.item.category.id;
					this.state.path = this.get_path(event.item.category.id);

					this.state.select_mode = false;

					if (this.opts.onchangehandler) {
						this.opts.onchangehandler(event.item.category, this.state.identifier);
					}
				}

				scrollToElement('#category-button');
			}
		}


		this.go_back = event => {
			event.preventDefault();
			var level = parseInt($(event.target).attr("data-level"));

			this.init_levels(level -1);

			this.state.active_level = level - 1;
		}


		this.get_level = id => {
			var level = -1;
			var category = this.state.categories.find( item => item.id == id) || null;

			while (category) {
				level++;
				category = this.state.categories.find( item => item.id == category.parent_id ) || null;
			}
			return level;
		}


		this.get_path = id => {
			var path = "";
			var category = this.state.categories.find( item => item.id == id) || null;
			
			while (category) {
				path = category.title + (path ? " » " : "") + path;
				category = this.state.categories.find( item => item.id == category.parent_id ) || null;
			}
			return path;
		}


		this.load_categories = () => {
			var tag = this;
			api_request(
				'categories/list_',
				{},
				function(result) {
					tag.state.categories = result.data;

					// set the professional alloewd categories to display
					if (tag.state.allowed_categories && tag.state.allowed_categories.length) {
						tag.state.allowed_categories.map ( category_id => {
							tag.state.categories.find ( x => x.id === category_id ).allowed = true;
						});
					} else {
						// allow all categories
						tag.state.categories.map( item => {
							item.allowed = true;
						});
					}

					tag.set_selected_categories();

					tag.update();
				}, null, this.toggle_loader
			);
		}


		this.toggle_loader = value => {
			this.state.loading = value;
			this.update();
		}
	</script>
</control-category-select>